
with System;

with Interfaces.C;
with Interfaces.C.Strings;

with Ada.Text_IO; use Ada.Text_IO;

with Image_Reference;
with Magick_Image.API;
with Magick_Options;
with Magick_Type;

package body Magick_Image is

   type Raw_Data is array (Interfaces.C.size_t range <>) of Magick_Type.UByte;

   procedure Read_File (theImage : out Magick_Image.API.Class_Image.MPP_Image;
                        File_Name : String) is
      use Interfaces.C;
      use Magick_Image.API;

      CPP_Image    : Magick_Image.API.Class_Image.MPP_Image;
   begin
      theImage.Read (To_C (" " & File_Name));
   exception
      when others =>
         New_Line;
         Put_Line ("An exception occurred in Magick_Image.Read_File.");
         raise;
   end Read_File;

   --  -------------------------------------------------------------------------

    procedure Write_File (theImage : in out Magick_Image.API.Class_Image.MPP_Image;
                          File_Name : String) is
      use Interfaces.C;
      use Magick_Image.API;

      CPP_Image    : Magick_Image.API.Class_Image.MPP_Image;
   begin
         Put_Line ("Magick_Image.Write_File: " & File_Name);
         theImage.Write (To_C (File_Name));
         Put_Line ("Magick_Image.Write_File: " & To_Ada (To_C (File_Name)));
         Put_Line ("Magick_Image.Write_File: " & File_Name);
   exception
      when others =>
         New_Line;
         Put_Line ("An exception occurred in Magick_Image.Write_File.");
         raise;
   end Write_File;

   --  -------------------------------------------------------------------------


end Magick_Image;
